<?php

namespace Drupal\services_token;

use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\Core\Site\Settings;

/**
 * Default implementation for realm resolver.
 */
class RealmResolver implements RealmResolverInterface {

  /**
   * Settings.
   *
   * @var \Drupal\Core\Site\Settings
   */
  protected $settings;

  /**
   * Config factory.
   *
   * @var \Drupal\Core\Config\ConfigFactoryInterface
   */
  protected $configFactory;

  /**
   * Constructs a realm resolver.
   *
   * @param \Drupal\Core\Site\Settings $settings
   *   The settings obpject.
   * @param \Drupal\Core\Config\ConfigFactoryInterface
   *   The config factory.
   */
  public function __construct(
    Settings $settings,
    ConfigFactoryInterface $config_factory
  ) {
    $this->settings = $settings;
    $this->configFactory = $config_factory;
  }

  /**
   * {@inheritdoc}
   */
  function resolveRealm(): string {
    $site_config = $this->configFactory->get('system.site');
    $site_name = $site_config->get('name');
    return $this->settings->get('services_token_realm', $site_name . ' API');
  }

}
